//---------------------------------------------------------------------------
// ScreenKeyBoard (NumberPad) by Dong-Liang Lee http://dllee.ktop.com.tw
// <2004-09-18> 쪩A۰èùΥkAWϥܻܥثe
//              Active W١C
//              w BUGAuUƦrA׬O_ Number LockedC
//              Dnγ~Gϥ NoteBook ϥΪ̦]L@YANumberPad
//                        ާ@AϥΦpuAiHݭn NumberPadC
//              ӹwp|[ StatPlus2 C
//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "testKeyboardUnit.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFormKeyBoard *FormKeyBoard;
bool bMouseInForm;
bool bMouseInXButton;
bool bMouseDown;
int iDownX,iDownY;
bool bStickLeft;
HWND hwndLastActived=0;
//---------------------------------------------------------------------------
__fastcall TFormKeyBoard::TFormKeyBoard(TComponent* Owner)
  : TForm(Owner)
{
  Btn0->Tag=VK_NUMPAD0;
  Btn1->Tag=VK_NUMPAD1;
  Btn2->Tag=VK_NUMPAD2;
  Btn3->Tag=VK_NUMPAD3;
  Btn4->Tag=VK_NUMPAD4;
  Btn5->Tag=VK_NUMPAD5;
  Btn6->Tag=VK_NUMPAD6;
  Btn7->Tag=VK_NUMPAD7;
  Btn8->Tag=VK_NUMPAD8;
  Btn9->Tag=VK_NUMPAD9;
  BtnPlus->Tag=VK_ADD;
  BtnMinus->Tag=VK_SUBTRACT;
  BtnSlash->Tag=VK_DIVIDE;
  BtnStar->Tag=VK_MULTIPLY;
  BtnDot->Tag=VK_DECIMAL;
  BtnNumberLock->Tag=VK_NUMLOCK;
  BtnEnter->Tag=VK_RETURN;
  ImageList1->GetBitmap(2,ImgBtnClose->Picture->Bitmap);
  this->BorderStyle=bsNone;
  this->Width=103;
  this->Height=152;
  bStickLeft=true;
  bMouseInForm=true;
  DoubleBuffered=true;
}
//---------------------------------------------------------------------------
void __fastcall TFormKeyBoard::FormCreate(TObject *Sender)
{ // http://delphi.ktop.com.tw/TOPIC.ASP?TOPIC_ID=55691
  long wsex=::GetWindowLongPtr(Handle,GWL_EXSTYLE);
  wsex |= WS_EX_NOACTIVATE;
  ::SetWindowLongPtr(Handle,GWL_EXSTYLE,wsex);
}
//---------------------------------------------------------------------------
void __fastcall TFormKeyBoard::BtnClick(TObject *Sender)
{
  TButton *Btn=dynamic_cast<TButton*>(Sender);
  if(Btn==NULL)return;
  BYTE scancode = (BYTE)MapVirtualKey(Btn->Tag, 0);
  keybd_event(Btn->Tag,scancode,KEYEVENTF_EXTENDEDKEY|0,0);
  keybd_event(Btn->Tag,scancode,KEYEVENTF_EXTENDEDKEY|KEYEVENTF_KEYUP,0);
  ImageList1->GetBitmap(2,ImgBtnClose->Picture->Bitmap);
  ImgBtnClose->Invalidate();
  SetWindowPos(this->Handle,HWND_TOPMOST,0,0,0,0,SWP_NOMOVE|SWP_NOSIZE);
}
//---------------------------------------------------------------------------
void __fastcall TFormKeyBoard::FormMouseDown(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y)
{
  bMouseDown=true;
  iDownX=X;
  iDownY=Y;
  SetWindowPos(this->Handle,HWND_TOPMOST,0,0,0,0,SWP_NOMOVE|SWP_NOSIZE);
}
//---------------------------------------------------------------------------
void __fastcall TFormKeyBoard::FormMouseUp(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y)
{
  bMouseDown=false;
}
//---------------------------------------------------------------------------
void __fastcall TFormKeyBoard::FormMouseMove(TObject *Sender, TShiftState Shift,
      int X, int Y)
{
  if(bMouseInForm==false)
  {
    bMouseInForm=true;
    this->Color=clActiveCaption;
    if(bStickLeft) this->Left=Screen->Width-this->Width; // Show
    else           this->Left=0; // Show
  }
  if(bMouseInXButton==true)
  {
    bMouseInXButton=false;
    ImageList1->GetBitmap(2,ImgBtnClose->Picture->Bitmap);
    ImgBtnClose->Invalidate();
  }
  if(bMouseDown)
  {
    if(bStickLeft)
    {
      if(-X>Screen->Width*3/4)
      {
        bStickLeft=false;
        this->Left=0;
      }
    }
    else
    {
      if(X>Screen->Width*3/4)
      {
        bStickLeft=true;
        this->Left=Screen->Width-this->Width;
      }
    }
    // this->Left+=X-iDownX;  // ]ڥuQ Y V
    this->Top+=Y-iDownY;
  }
}
//---------------------------------------------------------------------------
void __fastcall TFormKeyBoard::ImgBtnCloseClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TFormKeyBoard::ImgBtnCloseMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
  if(bMouseInForm==false)
  {
    bMouseInForm=true;
    this->Color=clActiveCaption;
    if(bStickLeft) this->Left=Screen->Width-this->Width; // Show
    else           this->Left=0; // Show
  }
  if(bMouseInXButton==false)
  {
    bMouseInXButton=true;
    ImageList1->GetBitmap(1,ImgBtnClose->Picture->Bitmap);
    ImgBtnClose->Invalidate();
  }
}
//---------------------------------------------------------------------------
void __fastcall TFormKeyBoard::Timer1Timer(TObject *Sender)
{
  // Try to find the foreground windows
  // http://delphi.ktop.com.tw/TOPIC.ASP?TOPIC_ID=37920 A}@U
  HWND hwndThisActived=GetForegroundWindow();
  if(hwndLastActived!=hwndThisActived)
  {
    if(hwndThisActived==this->Handle)
    {
      hwndThisActived=hwndLastActived;
      if(hwndLastActived!=0)
        SetForegroundWindow(hwndLastActived);
    }
    SetWindowPos(this->Handle,HWND_TOPMOST,0,0,0,0,SWP_NOMOVE|SWP_NOSIZE);
    hwndLastActived=hwndThisActived;

    char LastActivedTitle[256];
    GetWindowText(hwndLastActived,LastActivedTitle,256);
    this->Image1->Hint=AnsiString(LastActivedTitle);
  }

  if(bMouseDown==false && bMouseInForm==true)
  {
    POINT MousePos;
    if (GetCursorPos(&MousePos))
    {
      if(this->Left > MousePos.x
      || this->Top > MousePos.y
      || this->Left+this->Width < MousePos.x
      || this->Top+this->Height < MousePos.y)
      {
        bMouseInForm=false;
        this->Color=clNavy;//clInactiveCaption;
        if(bStickLeft) this->Left=Screen->Width-3; // Hide
        else           this->Left=3-this->Width; // Hide
        if(bMouseInXButton==true)
        {
          bMouseInXButton=false;
          ImageList1->GetBitmap(2,ImgBtnClose->Picture->Bitmap);
          ImgBtnClose->Invalidate();
        }
      }
    }
  }
}
//---------------------------------------------------------------------------

