//---------------------------------------------------------------------------

#ifndef testKeyboardUnitH
#define testKeyboardUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <Graphics.hpp>
#include <ImgList.hpp>
#include <Menus.hpp>
//---------------------------------------------------------------------------
class TFormKeyBoard : public TForm
{
__published:	// IDE-managed Components
  TButton *Btn0;
  TButton *Btn1;
  TButton *Btn2;
  TButton *Btn3;
  TButton *Btn4;
  TButton *Btn5;
  TButton *Btn6;
  TButton *Btn7;
  TButton *Btn8;
  TButton *Btn9;
  TButton *BtnPlus;
  TButton *BtnMinus;
  TButton *BtnSlash;
  TButton *BtnStar;
  TButton *BtnDot;
  TButton *BtnNumberLock;
  TButton *BtnEnter;
  TImage *Image1;
  TImageList *ImageList1;
  TImage *ImgBtnClose;
  TTimer *Timer1;
  void __fastcall FormCreate(TObject *Sender);
  void __fastcall BtnClick(TObject *Sender);
  void __fastcall FormMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
  void __fastcall FormMouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
  void __fastcall FormMouseMove(TObject *Sender, TShiftState Shift, int X,
          int Y);
  void __fastcall ImgBtnCloseClick(TObject *Sender);
  void __fastcall ImgBtnCloseMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
  void __fastcall Timer1Timer(TObject *Sender);
private:	// User declarations
public:		// User declarations
  __fastcall TFormKeyBoard(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TFormKeyBoard *FormKeyBoard;
//---------------------------------------------------------------------------
#endif
